process DEMODUL =
     { integer LONG_SEQ, DEB_AUTO, N, MH;
       real MU1;
       [N]real H1, H1_HILB;
       [LONG_SEQ]integer AP;
       [MH]complex H0; }
     ( ? real SORTIE_LIGNE;
       ! real MODERREUR;
         integer SYMBOLE;
     )
   pragmas 
      COMMENT " The main objective of a digital demodulator"
              " is to regenerate the broadcasted signal. "
              "It identifies all the characteristics of the channel "
              "to reconstitute with an inverse filter the signal "
              "(digital equalizer)."
              " It have to reconstitute the rythm of the digits sequence"
              " to synchronize the transmitter and the receiver."
              " There is an unmixer to reconstitute the sequence "
              "of all broadcasted   digits."
   end pragmas
   (| (| D1 := TRANSFILT{N,H1}(SORTIE_LIGNE)
       | D2 := TRANSFILT{N,H1_HILB}(SORTIE_LIGNE)
       | (| DD := D1@D2
          | CPT := counterOf(^DD)
          | EE := DD when ((CPT modulo 6)=0)
          |)
       | (| ERREUR := A-SS |)
       | AJUST{MH,MU1,H0}
       | EGFILT{MH,H0}
       | (| MODERREUR := modu(ERREUR) |)
       | (| CPT_TRIBIT := counterOf(^SS)
          | C := CPT_TRIBIT<=DEB_AUTO
          | C_CPT_TRIBIT := CPT_TRIBIT when C
          | CPTDECAL := MAX0(1,(C_CPT_TRIBIT-integer(MH/2))+1)
          | (A1,SYMBOLE1) := APPREND{LONG_SEQ,AP}(CPTDECAL)
          | C_SS := SS when (not C)
          | (A2,SYMBOLE2) := AUTO_ADAPT{}(C_SS)
          | A := A1 default A2
          | SYMBOLE := SYMBOLE1 default SYMBOLE2
          |)
       |)/ A, SS, H, ERREUR, EE, D2, D1 |)
   where 
   integer CPT, SYMBOLE1, SYMBOLE2, CPTDECAL, C_CPT_TRIBIT, CPT_TRIBIT;
   complex A init complex0, A1, A2, DD, EE, ERREUR, SS, C_SS;
   real D1, D2;
   constant complex complex0 = 0.0e+0@0.0e+0;
   [MH]complex H;
   boolean C;
   process MAX0 =
        ( ? integer A;
            integer B;
          ! integer R;
        )
      pragmas 
         COMMENT " returns the greatest of the values"
                 " specified in the argument list "
      end pragmas
      (| R := if A>B then A else B |)
   ; 
   process TRANSFILT =
        { integer N;
          [N]real H; }
        ( ? real EE;
          ! real SS;
        )
      pragmas 
         COMMENT " SORTIE_LIGNE is the input signal of the demodulator"
                 " (its frequency  is about fe =9600 Hz, 2 filters are used "
                 " to transform it to the input of the digital equalizer D1, D2 .  "
      end pragmas
      (| VECTE := EE window N
       | array I to N-1
         of (| VS[I] := (VS[?][I-1]\\0.0e0)+(VECTE[I]*H[I]) |)
         end 
       | SS := VS[N-1]
       |)
      where 
      [N]real VECTE init [{ to (N-1)}:0.0e+0], VS;
      real S;
      end
   ; 
   process EGFILT =
        { integer N;
          [N]complex H0; }
        ( ? complex EE;
            [N]complex H;
          ! complex SS;
        )
      pragmas 
         COMMENT " U is obtain by sub sampling D1 and D2 "
                 "with the frequency fb = 1600 Hz = fe/6 "
      end pragmas
      (| (| VECTE := EE window N
          | ZH := H$1
          |)
       | array I to N-1
         of (| VS[I] := (VS[?][I-1]\\complex0)+(VECTE[I]*ZH[I]) |)
         end 
       | SS := VS[N-1]
       |)
      where 
      [N]complex VECTE init [{ to (N-1)}:complex0], VS, ZH init H0;
      complex S;
      end
   ; 
   process AJUST =
        { integer N;
          real MU;
          [N]complex H0; }
        ( ? complex EE;
            complex ERREUR;
          ! [N]complex H;
        )
      (| ZH := H$1
       | VECTE := EE window N
       | array I to N-1
         of (| H[I] := ZH[I]+(complex(MU)*ERREUR*AA[I])
             | AA[I] := conj(VECTE[I])
             |)
         end 
       |)
      where 
      [N]complex VECTE init [{ to (N-1)}:complex0], ZH init H0, AA;
      end
   ; 
   process APPREND =
        { integer LONG_SEQ;
          [LONG_SEQ]integer AP; }
        ( ? integer CPT;
          ! complex AA;
            integer K0;
        )
      (| K0 := AP[CPT]
       | (| Z_PHI := PHI$1
          | PHI := Z_PHI+((real(3.1415926e+0)/4.0)*(1.0+real(K0)))
          |)
       | AA := real(cos(dreal(PHI)))@real(sin(dreal(PHI)))
       |)
      where 
      real PHI, Z_PHI init (15.0*3.1415965e+0)/8.0e+0;
      end
   ; 
   process AUTO_ADAPT =
        ( ? complex S;
          ! complex A;
            integer K0;
        )
      (| (| (| S ^= V2 ^= V1
             | V2 := real(0.382683e+0)
             | V1 := real(0.92388e+0)
             | S2 := ipart(S)
             | S1 := real(S)
             |)
          | A1 := (((((V1 when (S1>S2)) default (V2 when (not (S1>S2)))) when (S2>0.0e+0)) default (((V1 when (S1>(-S2))) default (V2 when (not (S1>(-S2))))) when (not (S2>0.0e+0)))) when (S1>0.0e+0)) default ((((((-V2) when (S1>(-S2))) default ((-V1) when
                  (not (S1>(-S2))))) when (S2>0.0e+0)) default ((((-V1) when (S1<S2)) default ((-V2) when (not (S1<S2)))) when (not (S2>0.0e+0)))) when (not (S1>0.0e+0)))
          | A2 := (((((V2 when (S1>S2)) default (V1 when (not (S1>S2)))) when (S2>0.0e+0)) default ((((-V2) when (S1>(-S2))) default ((-V1) when (not (S1>(-S2))))) when (not (S2>0.0e+0)))) when (S1>0.0e+0)) default (((((V1 when (S1>(-S2))) default (V2 when
                  (not (S1>(-S2))))) when (S2>0.0e+0)) default ((((-V2) when (S1<S2)) default ((-V1) when (not (S1<S2)))) when (not (S2>0.0e+0)))) when (not (S1>0.0e+0)))
          | AA := A1@A2
          |)
       | A := (AA cell (^S)) when (^S)
       | (| Z_PHI := PHI$1
          | PHI := arg(A)
          |)
       | DDELTA := (4.0/3.14159265e+0)*(PHI-Z_PHI)
       | DELTA := (DDELTA when (DDELTA>0.0e+0)) default ((DDELTA+8.0) when (not (DDELTA>0.0e+0)))
       | K0 := integer(floor(dreal(DELTA)))-1
       |)
      where 
      real DELTA, DDELTA, S1, S2, A1, A2, V1, V2, PHI, Z_PHI init 0.0e+0;
      complex AA;
      end
   ; 
   process counterOf =
        ( ? event H;
          ! integer N;
        )
      pragmas 
         COMMENT " counts the numbers that H occured"
      end pragmas
      (| N := ZN+1
       | ZN := N$1 init 0
       | N ^= H
       |)
      where 
      integer ZN;
      end
   ; 
   end
; 
