process MODUL =
     { integer L;
       [L]real H0; }
     ( ? boolean BIT;
         boolean FE;
       ! real ENTREELIGNE;
     )
   pragmas 
      COMMENT " The modulator assure the broadcast of the digit information"
              " through the channel of transmission . "
              "After mixing and coding the future broadcasted  digits, we made"
              " a PSK : Phase-Shift -Keying with synchronous running."
              "The frequency of the carrier is constant and when some datas"
              " have to be send PSK' s circuits interupt the carrier's wave"
              "and this wave' s phase alters. Then the others side of the "
              "channel the receivers  can see  the alteration. "
              "All the PSK' s circuits can recognize 8 diferent alterations. "
              "With 3 digits 8 numbers can be represented. Then the PSK' s"
              " circuit use all the combinasion of 3 digits to represent the 8 alterations."
   end pragmas
   (| (| (| (| FE ^= BIT
             | CPTFE := counterOf(^FE)
             | ENTREE := BIT when ((CPTFE modulo 2)=0)
             |)
          | ENTREE_1 := ENTREE
          |) where boolean ENTREE; end
       | (| ENTREE := SORTIE
          | K_in := K
          | CODEUR{}
          |) where integer K_in;
                   [3]boolean ENTREE; end
       | (| SX1 := X1 cell (^FE)
          | SX2 := X2 cell (^FE)
          |)
       | (| CPT6 := CPTFE
          | A1 := (SX1 when ((CPT6 modulo 6)=0)) default 0.0e+0
          | A2 := (SX2 when ((CPT6 modulo 6)=0)) default 0.0e+0
          |)
       | P2 := TRANSFILT{L,H0}(A2)
       | P1 := TRANSFILT{L,H0}(A1)
       | (| N := (CPT6-6) modulo 16
          | TETA := (3.0*3.1416e0*real(N))/8.0
          |)
       | (| COS3PIN8 := real(cos(dreal(TETA))) |)
       | (| SIN3PIN8 := real(sin(dreal(TETA))) |)
       | (| ENTREELIGNE := 4.0*((P1*SIN3PIN8)+(P2*COS3PIN8)) |)
       | (| ENTREE := ENTREE_1
          | SERIE_PAR{}
          |) where boolean ENTREE; end
       |)/ SORTIE, SIN3PIN8, COS3PIN8, TETA, P1, P2, A2, A1, CPT6, SX2, SX1, X2, X1, K, ENTREE_1 |)
   where 
   boolean ENTREE, ENTREE_1;
   [3]boolean SORTIE;
   integer CPT6, K init 0, CPTFE, K1, N;
   real TETA;
   real SIN3PIN8, COS3PIN8, X1, X2, SX1, SX2, A1, A2, P1, P2;
   process SERIE_PAR =
        ( ? boolean ENTREE;
          ! [3]boolean SORTIE;
        )
      pragmas 
         COMMENT " The datas are in package of 3 digits consecutives, the signaling rate is  1600 bauds"
      end pragmas
      (| K_in := counterOf(^ENTREE)
       | S := ENTREE window 3
       | SORTIE := S when ((K_in modulo 3)=0)
       |)
      where 
      integer K_in;
      [3]boolean S;
      end
   ; 
   process TRANSFILT =
        { integer N;
          [N]real H; }
        ( ? real EE;
          ! real SS;
        )
      pragmas 
         COMMENT " the impulsionel response of the filter is"
                 " (1/fe)*((8*f1*cosB-sinA)/(pi*t(1-(8*f*t)^2))), f1 = 1/(2*Tb), fe = 9600Hz"
      end pragmas
      (| VECTE := EE window N
       | array I to N-1
         of (| VS[I] := (VS[?][I-1]\\0.0e0)+(VECTE[I]*H[I]) |)
         end 
       | SS := VS[N-1]
       |)
      where 
      [N]real VECTE, VS;
      end
   ; 
   process counterOf =
        ( ? event H;
          ! integer N;
        )
      pragmas 
         COMMENT " counts the numbers that H occured"
      end pragmas
      (| N := ZN+1
       | ZN := N$1 init 0
       | N ^= H
       |)
      where 
      integer ZN;
      end
   ; 
   process CODEUR =
        ( ? [3]boolean ENTREE;
            integer K_in;
          ! real X1;
            real X2;
            integer K;
        )
      pragmas 
         COMMENT " Each package of 3 digits is represented with a diference"
                 " of K0 phase from the previous package. "
                 " It constitute an element to transmit : "
                 "x(n*Tb) = x1(n*Tb)+ix2(n*Tb) = exp(i*Kn*pi/4) , "
                 " Kn = Kn+1 +K0 is the absolute value of the phase "
                 "of the transmitted symbole."
      end pragmas
      (| (| K1 := ((4 when ENTREE[2]) default (5 when (not ENTREE[2]))) when ENTREE[1] when ENTREE[0]
          | K2 := ((7 when ENTREE[2]) default (6 when (not ENTREE[2]))) when (not ENTREE[1]) when ENTREE[0]
          | K3 := ((3 when ENTREE[2]) default (2 when (not ENTREE[2]))) when ENTREE[1] when (not ENTREE[0])
          | K4 := ((0 when ENTREE[2]) default (1 when (not ENTREE[2]))) when (not ENTREE[1]) when (not ENTREE[0])
          | K0 := K1 default K2 default K3 default K4
          |)
       | ZK := K_in$1
       | K := (ZK+K0) modulo 8
       | TETA := (3.1416e+0*dreal(K))/4.0
       | (| X1 := real(cos(TETA))
          | X2 := real(sin(TETA))
          |)
       |)
      where 
      integer K0, K1, K2, K3, K4, ZK, K_1;
      dreal TETA;
      end
   ; 
   end
; 
