process MODUL_TRA =
     ( ? boolean BIT, FE;
       ! real ENTREELIGNE;
     )
   pragmas 
      Main
      COMMENT " The modulator assure the broadcast of the digit information"
              " through the channel of transmission . "
              "After mixing and coding the future broadcasted  digits, we made"
              " a PSK : Phase-Shift -Keying with synchronous running."
              "The frequency of the carrier is constant and when some datas"
              " have to be send PSK' s circuits interupt the carrier's wave"
              "and this wave' s phase alters. Then the others side of the "
              "channel the receivers  can see  the alteration. "
              "All the PSK' s circuits can recognize 8 diferent alterations. "
              "With 3 digits 8 numbers can be represented. Then the PSK' s"
              " circuit use all the combinasion of 3 digits to represent the 8 alterations."
      COMMENT " counts the numbers that H occured"
      COMMENT " Each package of 3 digits is represented with a diference"
              " of K0 phase from the previous package. "
              " It constitute an element to transmit : "
              "x(n*Tb) = x1(n*Tb)+ix2(n*Tb) = exp(i*Kn*pi/4) , "
              " Kn = Kn+1 +K0 is the absolute value of the phase "
              "of the transmitted symbole."
      COMMENT " the impulsionel response of the filter is"
              " (1/fe)*((8*f1*cosB-sinA)/(pi*t(1-(8*f*t)^2))), f1 = 1/(2*Tb), fe = 9600Hz"
      COMMENT " the impulsionel response of the filter is"
              " (1/fe)*((8*f1*cosB-sinA)/(pi*t(1-(8*f*t)^2))), f1 = 1/(2*Tb), fe = 9600Hz"
      COMMENT " The datas are in package of 3 digits consecutives, the signaling rate is  1600 bauds"
      COMMENT " counts the numbers that H occured"
   end pragmas
   (| (| XZX := ^BIT
       | XZX ^= BIT ^= FE ^= ENTREELIGNE
       | ACT_XZX{}
       |) |)
   where 
   constant integer L = 31;
   constant [31]real H0 = [[0]:-2.50088e-03,[1]:5.47133e-04,[2]:4.57670e-03,[3]:7.07355e-03,[4]:5.42707e-03,[5]:-1.57406e-03,[6]:-1.25044e-02,[7]:-2.30009e-02,[8]:-2.67637e-02,[9]:-1.76839e-02,[10]:7.61266e-03,[11]:4.78121e-02,[12]:9.64387e-02,[13]:
                           1.43239e-01,[14]:1.77087e-01,[15]:1.89437e-01,[16]:1.77087e-01,[17]:1.43239e-01,[18]:9.64387e-02,[19]:4.78121e-02,[20]:7.61266e-03,[21]:-1.76839e-02,[22]:-2.67637e-02,[23]:-2.30009e-02,[24]:-1.25044e-02,[25]:-1.57406e-03,[26]:
                           5.42707e-03,[27]:7.07355e-03,[28]:4.57670e-03,[29]:5.47133e-04,[30]:-2.50088e-03];
   event XZX;
   process ACT_XZX =
        ( )
      (| XZX ^= CPTFE ^= N ^= TETA ^= SIN3PIN8 ^= COS3PIN8 ^= SX1 ^= SX2 ^= A1 ^= A2 ^= P1 ^= P2 ^= ZN ^= VECTE ^= VS ^= VECTE_338 ^= VS_339 ^= y_374 ^= y_376 ^= y_384 ^= y_386
       | (| XZX_405 := when ((CPTFE modulo 2)=0)
          | ACT_XZX_405{}
          | CLK := when (not ((CPTFE modulo 2)=0))
          |)
       | (| CLK_85 := when ((CPTFE modulo 6)=0)
          | CLK_86 := when (not ((CPTFE modulo 6)=0))
          |)
       | (| ENTREELIGNE := 4.0*((P1*SIN3PIN8)+(P2*COS3PIN8))
          | CPTFE := ZN+1
          | N := (CPTFE-6) modulo 16
          | TETA := ((3.0*3.1416e0*real(N))/8.0) when XZX
          | SX1 := (X1 when CLK_SORTIE) cell XZX init 0.0e0
          | SX2 := (X2 when CLK_SORTIE) cell XZX init 0.0e0
          | A1 := (SX1 when CLK_85) default (0.0e+0 when CLK_86)
          | A2 := (SX2 when CLK_85) default (0.0e+0 when CLK_86)
          | P1 := VS_339[30]
          | P2 := VS[30]
          | ZN := CPTFE$1 init 0
          | VECTE := A2 window 31 init [{_I_423 in 0 to 29 step 1}:0.0e0]
          | array I to 30
            of (| VS[I] := (VS[?][I-1]\\0.0e0)+(VECTE[I]*H0[I]) |)
            end 
          | VECTE_338 := A1 window 31 init [{_I_0_431 in 0 to 29 step 1}:0.0e0]
          | array I_342 to 30
            of (| VS_339[I_342] := (VS_339[?][I_342-1]\\0.0e0)+(VECTE_338[I_342]*H0[I_342]) |)
            end 
          | y_376 := dreal(TETA)
          | y_374 := cos(y_376)
          | COS3PIN8 := real(y_374)
          | y_386 := dreal(TETA)
          | y_384 := sin(y_386)
          | SIN3PIN8 := real(y_384)
          |)
       |)
      where 
      event CLK_SORTIE, CLK_86, CLK_85, CLK, XZX_405;
      dreal y_374, y_376, y_384, y_386;
      [31]real VECTE, VS, VECTE_338, VS_339;
      real TETA, SIN3PIN8, COS3PIN8, X1, X2, SX1, SX2, A1, A2, P1, P2;
      integer CPTFE, N, ZN;
      process ACT_XZX_405 =
           ( )
         (| XZX_405 ^= ENTREE ^= K_in_401 ^= S ^= ZN_408
          | (| CLK_SORTIE := when ((K_in_401 modulo 3)=0)
             | CLK_SORTIE ^= X1 ^= X2
             | ACT_CLK_SORTIE{}
             | CLK_125 := when (not ((K_in_401 modulo 3)=0))
             |)
          | (| ENTREE := BIT when XZX_405
             | K_in_401 := ZN_408+1
             | S := ENTREE window 3 init [{_I_1_438 in 0 to 1 step 1}:false]
             | ZN_408 := K_in_401$1 init 0
             |)
          |)
         where 
         event CLK_125;
         [3]boolean S;
         integer K_in_401, ZN_408;
         boolean ENTREE;
         process ACT_CLK_SORTIE =
              ( )
            (| CLK_SORTIE ^= SORTIE ^= K ^= K0 ^= ZK ^= TETA_233 ^= XZX_236 ^= XZX_244 ^= XZX_250 ^= XZX_255 ^= y ^= y_288
             | (| CLK_26 := when SORTIE[0]
                | CLK_27 := when (not SORTIE[0])
                |)
             | (| CLK_29 := when SORTIE[1]
                | CLK_30 := when (not SORTIE[1])
                |)
             | (| CLK_32 := when SORTIE[2]
                | CLK_33 := when (not SORTIE[2])
                |)
             | (| CLK_143 := CLK_30 ^* CLK_32 |)
             | (| CLK_145 := CLK_30 ^* CLK_33 |)
             | (| CLK_147 := CLK_29 ^* CLK_32 |)
             | (| CLK_149 := CLK_29 ^* CLK_33 |)
             | (| CLK_K3 := CLK_27 ^* CLK_29
                | CLK_K3 ^= K3
                | (| K3 := XZX_250 when CLK_K3 |)
                |)
             | (| CLK_K4 := CLK_27 ^* CLK_30
                | CLK_K4 ^= K4
                | (| K4 := XZX_255 when CLK_K4 |)
                |)
             | (| CLK_K1 := CLK_26 ^* CLK_29
                | CLK_K1 ^= K1
                | (| K1 := XZX_236 when CLK_K1 |)
                |)
             | (| CLK_K2 := CLK_26 ^* CLK_30
                | CLK_K2 ^= K2
                | (| K2 := XZX_244 when CLK_K2 |)
                |)
             | (| CLK_160 := CLK_26 ^+ CLK_K3 |)
             | (| SORTIE := S when CLK_SORTIE
                | K := (ZK+K0) modulo 8
                | K0 := (K1 when CLK_K1) default (K2 when CLK_K2) default (K3 when CLK_K3) default (K4 when CLK_K4)
                | ZK := K$1 init 0
                | TETA_233 := ((3.1416e+0*dreal(K))/4.0) when CLK_SORTIE
                | XZX_236 := (4 when CLK_32) default (5 when CLK_33)
                | XZX_244 := (7 when CLK_32) default (6 when CLK_33)
                | XZX_250 := (3 when CLK_32) default (2 when CLK_33)
                | XZX_255 := (0 when CLK_32) default (1 when CLK_33)
                | y := cos(TETA_233)
                | X1 := real(y)
                | y_288 := sin(TETA_233)
                | X2 := real(y_288)
                |)
             |)
            where 
            event CLK_160, CLK_K2, CLK_K1, CLK_K4, CLK_K3, CLK_149, CLK_147, CLK_145, CLK_143, CLK_33, CLK_32, CLK_30, CLK_29, CLK_27, CLK_26;
            dreal TETA_233, y, y_288;
            integer K, K0, K1, K2, K3, K4, ZK, XZX_236, XZX_244, XZX_250, XZX_255;
            [3]boolean SORTIE;
            end
         %ACT_CLK_SORTIE%; 
         end
      %ACT_XZX_405%; 
      end
   %ACT_XZX%; 
   end
%MODUL_TRA%; 
