process MODUL_bDC_TRA =
     ( ? boolean BIT, FE;
       ! real ENTREELIGNE;
     )
   pragmas 
      Main
      COMMENT " The modulator assure the broadcast of the digit information"
              " through the channel of transmission . "
              "After mixing and coding the future broadcasted  digits, we made"
              " a PSK : Phase-Shift -Keying with synchronous running."
              "The frequency of the carrier is constant and when some datas"
              " have to be send PSK' s circuits interupt the carrier's wave"
              "and this wave' s phase alters. Then the others side of the "
              "channel the receivers  can see  the alteration. "
              "All the PSK' s circuits can recognize 8 diferent alterations. "
              "With 3 digits 8 numbers can be represented. Then the PSK' s"
              " circuit use all the combinasion of 3 digits to represent the 8 alterations."
      COMMENT " counts the numbers that H occured"
      COMMENT " Each package of 3 digits is represented with a diference"
              " of K0 phase from the previous package. "
              " It constitute an element to transmit : "
              "x(n*Tb) = x1(n*Tb)+ix2(n*Tb) = exp(i*Kn*pi/4) , "
              " Kn = Kn+1 +K0 is the absolute value of the phase "
              "of the transmitted symbole."
      COMMENT " the impulsionel response of the filter is"
              " (1/fe)*((8*f1*cosB-sinA)/(pi*t(1-(8*f*t)^2))), f1 = 1/(2*Tb), fe = 9600Hz"
      COMMENT " the impulsionel response of the filter is"
              " (1/fe)*((8*f1*cosB-sinA)/(pi*t(1-(8*f*t)^2))), f1 = 1/(2*Tb), fe = 9600Hz"
      COMMENT " The datas are in package of 3 digits consecutives, the signaling rate is  1600 bauds"
      COMMENT " counts the numbers that H occured"
      Defined_clock_hierarchy
   end pragmas
   (| (| Tick := true
       | when Tick ^= BIT ^= FE ^= ENTREELIGNE
       | ACT_Tick{}
       |) |)
   where 
   constant integer L = 31;
   constant [31]real H0 = [[0]:-2.50088e-03,[1]:5.47133e-04,[2]:4.57670e-03,[3]:7.07355e-03,[4]:5.42707e-03,[5]:-1.57406e-03,[6]:-1.25044e-02,[7]:-2.30009e-02,[8]:-2.67637e-02,[9]:-1.76839e-02,[10]:7.61266e-03,[11]:4.78121e-02,[12]:9.64387e-02,[13]:
                           1.43239e-01,[14]:1.77087e-01,[15]:1.89437e-01,[16]:1.77087e-01,[17]:1.43239e-01,[18]:9.64387e-02,[19]:4.78121e-02,[20]:7.61266e-03,[21]:-1.76839e-02,[22]:-2.67637e-02,[23]:-2.30009e-02,[24]:-1.25044e-02,[25]:-1.57406e-03,[26]:
                           5.42707e-03,[27]:7.07355e-03,[28]:4.57670e-03,[29]:5.47133e-04,[30]:-2.50088e-03];
   boolean Tick;
   process ACT_Tick =
        ( )
      (| when Tick ^= CPTFE ^= N ^= TETA ^= SIN3PIN8 ^= COS3PIN8 ^= SX1 ^= SX2 ^= A1 ^= A2 ^= P1 ^= P2 ^= ZN ^= VECTE ^= VS ^= VECTE_338 ^= VS_339 ^= y_374 ^= y_376 ^= y_384 ^= y_386 ^= C_ZN ^= C_485 ^= C_488 ^= C_y_493
       | (| when C_ZN ^= C_y
          | ACT_C_ZN{}
          |)
       | (| ENTREELIGNE := 4.0*((P1*SIN3PIN8)+(P2*COS3PIN8))
          | CPTFE := ZN+1
          | N := (CPTFE-6) modulo 16
          | TETA := ((3.0*3.1416e0*real(N))/8.0) when Tick
          | SX1 := (X1 when C_y) cell Tick init 0.0e0
          | SX2 := (X2 when C_y) cell Tick init 0.0e0
          | A1 := (SX1 when C_485) default (0.0e+0 when C_488)
          | A2 := (SX2 when C_485) default (0.0e+0 when C_488)
          | P1 := VS_339[30]
          | P2 := VS[30]
          | ZN := CPTFE$1 init 0
          | VECTE := A2 window 31 init [{_I_423 in 0 to 29 step 1}:0.0e0]
          | array I to 30
            of (| VS[I] := (VS[?][I-1]\\0.0e0)+(VECTE[I]*H0[I]) |)
            end 
          | VECTE_338 := A1 window 31 init [{_I_0_431 in 0 to 29 step 1}:0.0e0]
          | array I_342 to 30
            of (| VS_339[I_342] := (VS_339[?][I_342-1]\\0.0e0)+(VECTE_338[I_342]*H0[I_342]) |)
            end 
          | y_376 := dreal(TETA)
          | y_374 := cos(y_376)
          | COS3PIN8 := real(y_374)
          | y_386 := dreal(TETA)
          | y_384 := sin(y_386)
          | SIN3PIN8 := real(y_384)
          | C_ZN := (CPTFE modulo 2)=0
          | C_485 := (CPTFE modulo 6)=0
          | C_488 := not ((CPTFE modulo 6)=0)
          | C_y_493 := left_tt ( C_y,C_ZN )
          |)
       |)
      where 
      boolean C_ZN, C_485, C_488, C_y, C_y_493;
      dreal y_374, y_376, y_384, y_386;
      [31]real VECTE, VS, VECTE_338, VS_339;
      real TETA, SIN3PIN8, COS3PIN8, X1, X2, SX1, SX2, A1, A2, P1, P2;
      integer CPTFE, N, ZN;
      process ACT_C_ZN =
           ( )
         (| when C_ZN ^= ENTREE ^= K_in_401 ^= S ^= ZN_408
          | (| when C_y ^= X1 ^= X2
             | ACT_C_y{}
             |)
          | (| ENTREE := BIT when C_ZN
             | K_in_401 := ZN_408+1
             | S := ENTREE window 3 init [{_I_1_438 in 0 to 1 step 1}:false]
             | ZN_408 := K_in_401$1 init 0
             | C_y := (K_in_401 modulo 3)=0
             |)
          |)
         where 
         [3]boolean S;
         integer K_in_401, ZN_408;
         boolean ENTREE;
         process ACT_C_y =
              ( )
            (| when C_y ^= SORTIE ^= K ^= K0 ^= ZK ^= TETA_233 ^= XZX_236 ^= XZX_244 ^= XZX_250 ^= XZX_255 ^= y ^= y_288 ^= C_498 ^= C_500 ^= C_502 ^= C_504 ^= C_506 ^= C_508 ^= C_K3 ^= C_K4 ^= C_K1 ^= C_K2 ^= C_535
             | (| when C_K3 ^= K3
                | (| K3 := XZX_250 when C_K3 |)
                |)
             | (| when C_K4 ^= K4
                | (| K4 := XZX_255 when C_K4 |)
                |)
             | (| when C_K1 ^= K1
                | (| K1 := XZX_236 when C_K1 |)
                |)
             | (| when C_K2 ^= K2
                | (| K2 := XZX_244 when C_K2 |)
                |)
             | (| SORTIE := S when C_y
                | K := (ZK+K0) modulo 8
                | K0 := (K1 when C_K1) default (K2 when C_K2) default (K3 when C_K3) default (K4 when C_K4)
                | ZK := K$1 init 0
                | TETA_233 := ((3.1416e+0*dreal(K))/4.0) when C_y
                | XZX_236 := (4 when C_506) default (5 when C_508)
                | XZX_244 := (7 when C_506) default (6 when C_508)
                | XZX_250 := (3 when C_506) default (2 when C_508)
                | XZX_255 := (0 when C_506) default (1 when C_508)
                | y := cos(TETA_233)
                | X1 := real(y)
                | y_288 := sin(TETA_233)
                | X2 := real(y_288)
                | C_498 := SORTIE[0]
                | C_500 := not SORTIE[0]
                | C_502 := SORTIE[1]
                | C_504 := not SORTIE[1]
                | C_506 := SORTIE[2]
                | C_508 := not SORTIE[2]
                | C_K3 := C_500 and C_502
                | C_K4 := C_500 and C_504
                | C_K1 := C_498 and C_502
                | C_K2 := C_498 and C_504
                | C_535 := C_498 or C_K3
                |)
             |)
            where 
            boolean C_498, C_500, C_502, C_504, C_506, C_508, C_K3, C_K4, C_K1, C_K2, C_535;
            dreal TETA_233, y, y_288;
            integer K, K0, K1, K2, K3, K4, ZK, XZX_236, XZX_244, XZX_250, XZX_255;
            [3]boolean SORTIE;
            end
         %ACT_C_y%; 
         end
      %ACT_C_ZN%; 
      end
   %ACT_Tick%; 
   end
%MODUL_bDC_TRA%; %(| C := not ((CPTFE modulo 2)=0)
                   | C_496 := not ((K_in_401 modulo 3)=0)
                   | C_511 := C_504 and C_506
                   | C_514 := C_504 and C_508
                   | C_517 := C_502 and C_506
                   | C_520 := C_502 and C_508
                   |)***WARNING: unused signals 
%
%
